// MDR
// version 1.0
// June 24, 2014
// Author: Vi Q. Ha


#ifndef PARAMETER
#define PARAMETER


#include <iostream>
//~ #include "RepastProcess.h"
#include <Properties.h>
#include "RepastProcess.h"
#include "dinner.h"

namespace mdr {
	
struct Parameters {
	int nTotal ;
	double deltaT;
	int stopAt;
	double rCut; 
	int numNetworkConnections;
	double buffer_size ;
	double desired_temperature;
	double rNebrShell;
	dinner::Vector<int> procArraySize;
	dinner::Line<double> worldSize;
	//~ dinner::Vector<double> localBoxSize;
	int cfg_print_interval;
	
	Parameters() : nTotal( 0), deltaT( 0.001), buffer_size( 3.0), desired_temperature( 1.0), rNebrShell(0.666), rCut(3.0), cfg_print_interval(1000) {}
	Parameters(int _nTotal, double _deltaT, double _buffer_size, double _desired_temperature, double _rNebrShell) : nTotal( _nTotal), deltaT( _deltaT), buffer_size( _buffer_size), desired_temperature(_desired_temperature), rNebrShell(_rNebrShell){}
	//~ Parameters(repast::Properties * props){
		//~ 
		//~ 
		//~ 
	//~ }
	

	void set(repast::Properties * props) {
		nTotal = repast::strToInt(props->getProperty("count.of.agents"));
		deltaT = repast::strToDouble(props->getProperty("deltaT"));  
		stopAt = repast::strToInt(props->getProperty("stop.at"));
		rCut = repast::strToDouble(props->getProperty("rCut"));  
		numNetworkConnections = repast::strToInt(props->getProperty("num.network.connections"));
		buffer_size = repast::strToDouble(props->getProperty("buffer.size"));
		desired_temperature = repast::strToDouble(props->getProperty("DesiredTemperature"));
		rNebrShell = repast::strToDouble(props->getProperty("rNebrShell"));
		procArraySize.x  = repast::strToInt(props->getProperty("nProcx"));
		procArraySize.y  = repast::strToInt(props->getProperty("nProcy"));
		procArraySize.z  = repast::strToInt(props->getProperty("nProcz"));
		double half_edge = repast::strToDouble(props->getProperty("procSideLength"));

		worldSize.set (-half_edge, -half_edge, -half_edge, half_edge, half_edge, half_edge);// Edited By Vi on 2014/09/29
		//~ localBoxSize = worldSize.dr() / procArraySize;
		cfg_print_interval =  repast::strToDouble(props->getProperty("cfg.print.interval"));
	}
	
	friend std::ostream & operator<<(std::ostream & os, const Parameters & p)
	{
		os << "Parameters:\n" ;
		os << "nTotal: " << p.nTotal << std::endl;
		os << "deltaT: " << p.deltaT << std::endl;
		os << "numNetworkConnections: " << p.numNetworkConnections << std::endl;
		os << "buffer_size: " << p.buffer_size << std::endl;
		os << "desired_temperature: " << p.desired_temperature << std::endl;
		os << "rNebrShell: " << p.rNebrShell << std::endl;
	}
};

} // end namespace

#endif
