// MDR
// version 3.0
// May 13 2014
// Authors: Vi Q. Ha, Yihao Zhang


#ifndef PART_AGENT
#define PART_AGENT

#include "AgentId.h"
#include "SharedContext.h"
#include "Grid.h"// 2014.06.13 Vi's edit 

#include "dinner.h" // Edited By Vi on 2014/09/18

/* Agents */

class ParticleAgent{
	
private:

    repast::AgentId   id_;

	
public:
	ParticleAgent(){}
    /// [1.2/1.3] create new constructor, add it to parameters AND initialization
    /// more nonsense
	
    ParticleAgent(
		repast::AgentId id, 
				dinner::Vector<long double> _origpos, 
				dinner::Vector<long double> _truepos, 
				dinner::Vector<long double> _posvec,
				dinner::Vector<long double> _velvec,
				dinner::Vector<long double> _n,
				dinner::Vector<long double> _ndot,
				std::vector<repast::AgentId> _bindToID
		):
		id_(id),
		original_position(_origpos), 
		true_position(_truepos), 
		position(_posvec),
		velocity(_velvec),
		orientation(_n),
		orientation_dot(_ndot),
				bindToID(_bindToID)
				{};
    //~ ~ParticleAgent();
	
    
    
    virtual repast::AgentId& getId(){                   return id_;    }
    virtual const repast::AgentId& getId() const {      return id_;    }
	
	int molID;

	dinner::Vector<long double> original_position;// Edited By Vi on 2014/08/13
	dinner::Vector<long double> true_position;// 2014.05.13 Vi's edit
	dinner::Vector<long double> position;// 2014.05.13 Vi's edit
	dinner::Vector<long double> velocity;// 2014.05.13 Vi's edit
	dinner::Vector<long double> acceleration; // 2014.05.13 Vi's edit
	dinner::Vector<long double> orientation; // Edited By Vi on 2014/08/26
	dinner::Vector<long double> orientation_dot; // Edited By Vi on 2014/08/26
	dinner::Vector<long double> orientation_acc; // Edited By Vi on 2014/08/26
	
	int nBind(){return bindToID.size();}
	std::vector<repast::AgentId> bindToID;
	repast::AgentId bindToID0;
	repast::AgentId bindToID1;
	
	bool is_binded(){return (nBind() > 0) ;}
	void bind_to(repast::AgentId _bindToID)
	{
		bindToID.clear();
		bindToID.push_back(_bindToID);
	}
	void unbind_all(){bindToID.clear();}
	
    /// [1.3/1.3] create a set fucntion
    /// more nonsense

			
			    void set(int currentRank,
			dinner::Vector<long double> _origpos, 
			dinner::Vector<long double> _truepos , 
			dinner::Vector<long double> _posvec , 
			dinner::Vector<long double> _velvec , 
			dinner::Vector<long double> _n , 
			dinner::Vector<long double> _ndot,
			std::vector<repast::AgentId> _bindToID) 
    {
		id_.currentRank(currentRank);
				original_position = _origpos;
				true_position = _truepos;
				position = _posvec;
				velocity = _velvec;
				orientation = _n; // Edited By Vi on 2014/08/26
				orientation_dot = _ndot; 
				bindToID = _bindToID;
	} 
	int getType(){		return getId().agentType(); }
    void zeroAcc() { // 2014.05.14 Vi's edit
		acceleration.set();
		orientation_acc.set();
	}

};




#include "ParticleAgentPackage.h"
#endif
