// MDR
// version 3.0
// May 13 2014
// Authors: Javier Romero, Vi Q. Ha, Yihao Zhang


#ifndef PART_AGENT_PACK
#define PART_AGENT_PACK


struct ParticleAgentPackage {
	
public:

	/// [2.1] add a variable here 
	/// more nonsense
	int    molID;
    int    id;
    int    rank;
    int    type;
    int    currentRank;
    //~ brunch::Vector original_position;
    //~ brunch::Vector true_position;
    //~ brunch::Vector velocity;
	//~ brunch::Vector orientation; // Edited By Vi on 2014/08/26
	//~ brunch::Vector orientation_dot; // Edited By Vi on 2014/08/26
    dinner::Vector<long double> original_position;
    dinner::Vector<long double> true_position;
    dinner::Vector<long double> position;
    dinner::Vector<long double> velocity;
	dinner::Vector<long double> orientation; 
	dinner::Vector<long double> orientation_dot; // Edited By Vi on 2014/09/18
		
	int nBind;
	
	int bind_id0;
	int bind_rank0;
	int bind_type0;
	int bind_currentRank0;
	int bind_id1;
	int bind_rank1;
	int bind_type1;
	int bind_currentRank1;
	
    /* Constructors */
    ParticleAgentPackage(){}; // For serialization
    //~ ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank, double _c, double _total);
    /// [2.2] create new constructor, add it to parameters AND initialization
    /// more nonsense
    ParticleAgentPackage(	
							int _molID,
							int _id, 	
							int _rank, 		
							int _type, 	
							int _currentRank, 			
							dinner::Vector<long double> _orig_pos, 
							dinner::Vector<long double> _true_pos, 
							dinner::Vector<long double>  _posvec, 
							dinner::Vector<long double>  _velvec, 
							dinner::Vector<long double>  _n, 
							dinner::Vector<long double>  _ndot,
							int _nBind,
							int _bind_id0, 	
							int _bind_rank0, 		
							int _bind_type0, 	
							int _bind_currentRank0, 
							int _bind_id1, 	
							int _bind_rank1, 		
							int _bind_type1, 	
							int _bind_currentRank1)							:
							molID(_molID),
							id(_id),
							rank(_rank), 
							type(_type), 
							currentRank(_currentRank), 
							original_position(_orig_pos), 
							true_position(_true_pos), 
							position(_posvec), 
							velocity(_velvec), 
							orientation(_n), 
							orientation_dot(_ndot),
							nBind(_nBind),
							bind_id0(_bind_id0),
							bind_rank0(_bind_rank0),
							bind_type0(_bind_type0),
							bind_currentRank0(_bind_currentRank0),
							bind_id1(_bind_id1),
							bind_rank1(_bind_rank1),
							bind_type1(_bind_type1),
							bind_currentRank1(_bind_currentRank1)
							 {}
							
							
    //~ ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank, brunch::Vector _orig_pos, brunch::Vector _true_pos, brunch::Vector _velvec ) :id(_id), rank(_rank), type(_type), currentRank(_currentRank), original_position(_orig_pos), true_position(_true_pos), velocity(_velvec) {}
    //~ ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank, brunch::Vector _true_pos, brunch::Vector _velvec ) :id(_id), rank(_rank), type(_type), currentRank(_currentRank), true_position(_true_pos), velocity(_velvec) {}
    //~ ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank, brunch::Vector _velvec ) :id(_id), rank(_rank), type(_type), currentRank(_currentRank), velocity(_velvec){}
    //~ ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank ) :id(_id), rank(_rank), type(_type), currentRank(_currentRank){}

	
    /* For archive packaging */
    template<class Archive>
    void serialize(Archive &ar, const unsigned int version){
		
       /// [2.3] add the variable to archive here
       /// more nonsense
		ar & molID;
		
        ar & id;
        ar & rank;
        ar & type;
        ar & currentRank;
        //~ ar & c;
        //~ ar & total;
       
        ar &   original_position.x;
        ar &   original_position.y;
        ar &   original_position.z;
        
        ar &   true_position.x;
        ar &   true_position.y;
        ar &   true_position.z;
        
        ar &   position.x;
        ar &   position.y;
        ar &   position.z;
        
        ar &   velocity.x;
        ar &   velocity.y;
        ar &   velocity.z;
        
        ar &   orientation.x;
        ar &   orientation.y;
        ar &   orientation.z;
        
        ar &   orientation_dot.x;
        ar &   orientation_dot.y;
        ar &   orientation_dot.z;
        
        
        ar &   nBind;
        
		ar & bind_id0;
        ar & bind_rank0;
        ar & bind_type0;
        ar & bind_currentRank0;
        
		ar & bind_id1;
        ar & bind_rank1;
        ar & bind_type1;
        ar & bind_currentRank1;
    }
	
};


/* Serializable Agent Package Data */

//~ ParticleAgentPackage::ParticleAgentPackage(){ }
//~ 
//~ ParticleAgentPackage::ParticleAgentPackage(int _id, int _rank, int _type, int _currentRank, double _c, double _total):
//~ id(_id), rank(_rank), type(_type), currentRank(_currentRank), c(_c), total(_total){ }


#endif
