// MDR
// version 1.0
// May 13 2014
// Authors: Javier Romero, Vi Q. Ha, Yihao Zhang


#ifndef PART_AGENT_PACK_EX
#define PART_AGENT_PACK_EX



#include "ParticleAgent.h"

/* Agent Package Provider */
class ParticleAgentPackageProvider {
	
private:
    repast::SharedContext<ParticleAgent>* agents;
	
public:
	
    ParticleAgentPackageProvider(repast::SharedContext<ParticleAgent>* agentPtr);
	
    void providePackage(ParticleAgent * agent, std::vector<ParticleAgentPackage>& out);
	
    void provideContent(repast::AgentRequest req, std::vector<ParticleAgentPackage>& out);
	
};

/* Agent Package Receiver */
class ParticleAgentPackageReceiver {
	
private:
    repast::SharedContext<ParticleAgent>* agents;
	
public:
	
    ParticleAgentPackageReceiver(repast::SharedContext<ParticleAgent>* agentPtr);
	
    ParticleAgent * createAgent(ParticleAgentPackage package);
	
    void updateAgent(ParticleAgentPackage package);
	
};


/* Data Collection */
class DataSource_AgentTotals : public repast::TDataSource<int>{
private:
	repast::SharedContext<ParticleAgent>* context;

public:
	DataSource_AgentTotals(repast::SharedContext<ParticleAgent>* c);
	int getData();
};
	

class DataSource_AgentCTotals : public repast::TDataSource<int>{
private:
	repast::SharedContext<ParticleAgent>* context;
	
public:
	DataSource_AgentCTotals(repast::SharedContext<ParticleAgent>* c);
	int getData();
};



#endif
