
// MDR
// version 3.0
// May 13 2014
// Author: Vi Q. Ha


#ifndef DINNER
#define DINNER

#include <iostream>
#include <vector>
#include <Point.h>

namespace dinner {

template <class Ttype>
class Pure_Point
{
    private:
    public:
        Ttype x, y, z;
        Pure_Point() : x(0), y(0), z(0){}
        Pure_Point(Ttype _x, Ttype _y, Ttype _z) : x(_x), y(_y), z(_z){}
        Pure_Point(Ttype _x, Ttype _y) : x(_x), y(_y), z(0){}
        Pure_Point(Ttype _x) : x(_x), y(0), z(0){}
		Pure_Point(std::vector<Ttype> _vec) ;
		Pure_Point(repast::Point<Ttype> _point)
		{
			this->set(_point);

		}
		void set(Ttype _x, Ttype _y, Ttype _z) {x =_x ; y = _y ; z = _z;}
		void set(Ttype _x, Ttype _y) {set(_x,_y,0);}
		void set(Ttype _x) {set(_x,0);}
		void set() {set(0);}
		void set(dinner::Pure_Point<Ttype> _vec)
		{
			x = _vec.x;
			y = _vec.y;
			z = _vec.z;
		}
		void set(std::vector<Ttype> _vec)
		{
			x=y=z=0;
			//~ std::cout <<"size:"<< _vec.size() ;
			if (_vec.size() > 2) z=_vec[2];
			if (_vec.size() > 1) y=_vec[1];
			if (_vec.size() > 0) x=_vec[0];
		}
		void set(repast::Point<Ttype> _point)
		{
			std::vector<Ttype> _stdvec(3);
			_point.copy(_stdvec);
			set(_stdvec);
		}
		
		void setAll(Ttype _a) {set(_a,_a,_a);}

};


template <class Ttype>
class Vector : public Pure_Point<Ttype>
{
	
	public:
		Vector(): Pure_Point<Ttype>(){}
        Vector(Ttype _x, Ttype _y, Ttype _z) : Pure_Point<Ttype>( _x,  _y,  _z) {}
        Vector(Ttype _x, Ttype _y) : Pure_Point<Ttype>( _x,  _y){}
        Vector(Ttype _x) : Pure_Point<Ttype>(_x){}
        Vector(std::vector<Ttype> _vec) : Pure_Point<Ttype>( _vec){}
        Vector(repast::Point<Ttype> _point) {
			this->set(_point);
		}
		
		Ttype dot(const Vector<Ttype> & b) const {
			return this->x * b.x + this->y * b.y + this->z * b.z;
		}
        
		void echo(){
		
			std::cout << " [" << this->x << "," <<  this->y << ","  << this->z << "] ";
		
		}
		template<typename Tcast>
		Vector<Tcast> multicast(){
			return Vector<Tcast>((Tcast)this->x, (Tcast)this->y , (Tcast)this->z );

			
		}
		std::vector<Ttype> get_stl()
		{
			std::vector<Ttype> v;
			v.clear();
			v.push_back(this->x);
			v.push_back(this->y);
			v.push_back(this->z);
			
			return v;
		}
		// operator overloading
		/// adding 2 vectors
		Vector<Ttype> operator+(const Vector<Ttype> & b) const	
		{
			return Vector<Ttype>(this->x + b.x, this->y + b.y, this->z + b.z);
		}
		
		/// subracting a vector by another
		Vector<Ttype> operator-(const Vector<Ttype> & b) const
		{
			return Vector<Ttype>(this->x - b.x, this->y - b.y, this->z - b.z);
		}
		//~ /// subracting all elements of a vector by a constant
		
		
		
		/// negative sign infront of a vector
		Vector<Ttype> operator-() const
		{
			return Vector<Ttype>(- this->x, - this->y, - this->z);
		}
		/// scaling a vector by a constant
		Vector<Ttype> operator*(long double n) const
		{
			return Vector<Ttype>(n * this->x, n * this->y, n * this->z);
		}
		/// dividing a vector by a constant
		Vector<Ttype> operator/(long double n) const
		{
			return Vector<Ttype>(this->x / n, this->y / n, this->z / n);
		}
		
		
		// special vector manipulations
		/// multiplying 2 vectors element by element
		template<typename Vtype>
		Vector<Ttype> operator*(Vector<Vtype> v) const
		{
			return Vector<Ttype>((Ttype)(this->x * v.x), (Ttype)(this->y * v.y), (Ttype)(this->z * v.z) );
		}
		/// divinding 2 vectors element by element
		template<typename Vtype>
		Vector<Ttype> operator/(Vector<Vtype> v) const
		{
			return Vector<Ttype>((Ttype)(this->x / v.x), (Ttype)(this->y / v.y), (Ttype)(this->z / v.z) );
		}
		
		
		
		// friends
		friend Vector<Ttype> operator*(long double n, const Vector<Ttype>  & a)
		{
			return a * n;
		}
		friend Vector<Ttype> operator/(long double n, const Vector<Ttype>  & a)
		{
			return Vector<Ttype>(n/a.x , n/a.y, n/a.z);

		}
		friend std::ostream & operator<<(std::ostream & os, const Vector<Ttype>  & v)
		{
			os << " [" << v.x << "," << v.y << "," << v.z << "] ";
		}
		
		int VLinear( const Vector<Ttype>  &  s)                                  
		{
			return ((this->z * (s).y + this->y) * (s).x + this->x);
			//~ (((p).z * (s).y + (p).y) * (s).x + (p).x)             \
			//~ (((p).z * (s).y + (p).y) * (s).x + (p).x)
		}
		
        
		Ttype VProd()
		{
			return (this->x * this->y * this->z);
		}
		Ttype VLen()
		{
			return sqrt(this->dot(*this)) ;
		}
		Vector<Ttype> VNormalize()
		{
			dinner:Vector<Ttype> Vec0;
			if(this->VLen() == 0)
			{
				Vec0.set();
			} else {
				Vec0 = *this/this->VLen() ;
			}
			return Vec0;
		}
		
		//~ template<typename Vtype>
		//~ void wrapX(Line<Vtype> worldSize)
		//~ {
			//~ if (this->x < worldSize.xMin()) this->x + worldSize.dx();
			//~ if (this->x > worldSize.xMax()) this->x - worldSize.dx();
		//~ }
		//~ template<typename Vtype>
		//~ void wrapY(Line<Vtype> worldSize)
		//~ {
			//~ if (this->y < worldSize.yMin()) this->y + worldSize.dy();
			//~ if (this->y > worldSize.yMax()) this->y - worldSize.dy();
		//~ }
		//~ template<typename Vtype>
		//~ void wrapZ(Line<Vtype> worldSize)
		//~ {
			//~ if (this->z < worldSize.zMin()) this->z + worldSize.dz();
			//~ if (this->z > worldSize.zMax()) this->z - worldSize.dz();
		//~ }
		//~ void wrapAround(dinner::Line<double> testRegion, dinner::Line<double> worldSize)
		//~ {
			//~ return (this->x * this->y * this->z);
		//~ }
		
		
};

template <class Ttype>
class Line
{
    private:
    public:
        Pure_Point<Ttype> p1;
        Pure_Point<Ttype> p2;
        //~ Ttype xMax(), xMin(), yMax(), yMin(), zMax(), zMin(); 
        //~ Ttype xHi(), xLo(), yHi(), yLo(), zHi(), zLo(); 
        //~ Ttype dx(), dy(), dz();
        
	Ttype xMin() {return p1.x;}
	Ttype yMin() {return p1.y;}
	Ttype zMin() {return p1.y;}
	Ttype xMax() {return p2.x;}
	Ttype yMax() {return p2.y;}
	Ttype zMax() {return p2.z;}
	
	Ttype xLo() {return p1.x;}
	Ttype yLo() {return p1.y;}
	Ttype zLo() {return p1.y;}
	Ttype xHi() {return p2.x;}
	Ttype yHi() {return p2.y;}
	Ttype zHi() {return p2.z;}
		
	Ttype dx() {return p2.x - p1.x;}
	Ttype dy() {return p2.y - p1.y;}
	Ttype dz() {return p2.z - p1.z;}
	
	
		
	Line() : p1(0), p2(0) {}
	Line(const Pure_Point<Ttype>  & _p1, const Pure_Point<Ttype>  & _p2 ) : p1(_p1), p2(_p2) {}
	Line(Ttype _x1, Ttype _y1, Ttype _z1, Ttype _x2, Ttype _y2, Ttype _z2 ) : p1(_x1,_y1,_z1), p2(_x2,_y2,_z2) {}
	Line(Ttype _x1, Ttype _y1, Ttype _x2, Ttype _y2 ) : p1(_x1,_y1), p2(_x2,_y2) {}
	void set(Ttype _x1, Ttype _y1, Ttype _z1, Ttype _x2, Ttype _y2, Ttype _z2 ){
		p1.set(_x1,_y1,_z1); 
		p2.set(_x2,_y2,_z2);
	}
	//~ Line() : p1(), p2() {}
	//~ Line(const Pure_Point<Ttype>  & _p1, const Pure_Point<Ttype>  & _p2 ) ;
	//~ Line(Ttype _x1, Ttype _y1, Ttype _z1, Ttype _x2, Ttype _y2, Ttype _z2 ) ;
	//~ Line(Ttype _x1, Ttype _y1, Ttype _x2, Ttype _y2 ) ;
	void setPoints( const Pure_Point<Ttype> & ap1, const Pure_Point<Ttype> & ap2)
	{
		p1 = ap1;
		p2 = ap2;
	}
	Vector<Ttype> dr()
	{
		return Vector<Ttype>(this->dx(), this->dy(), this->dz());
	}

};

//~ inline Vector<long double> toL(brunch::Vector _v) 
//~ {
	//~ return Vector<long double>(_v.x, _v.y , _v.z );
//~ }



template <class Ttype>
class Tensor
{
    private:
    public:
		
		Ttype H[3][3];
		Tensor(Ttype a[3][3]) {setMat(a);}
		Tensor() {setAll(0);}
        //~ M3(Ttype a[][]) 
        //~ {
			//~ setAll();
		//~ }
        
        
		void setAll(Ttype c) {
			for (int i = 0; i < 3 ; i++)
			{
				for (int j = 0; j < 3 ; j++)
				{
					H[i][j] = c;
				}
			}
		}
		void setMat(Ttype a0, Ttype a1, Ttype a2, 
					Ttype a3, Ttype a4, Ttype a5, 
					Ttype a6, Ttype a7, Ttype a8 )
		{
			setRow( 0,  a0,  a1,  a2);
			setRow( 1,  a3,  a4,  a5);
			setRow( 2,  a6,  a7,  a8);
		}
		void setMat(Ttype a[3][3])
		{
			for (int i = 0; i < 3 ; i++)
			{
				for (int j = 0; j < 3 ; j++)
				{
					H[i][j] = a[i][j];
				}
			}
			
		}
		void set(int i , int j , Ttype a)
		{
			H[i][j] = a;
		}
		void setRow(int i, Ttype a, Ttype b, Ttype c)
		{
			H[i][0] = a;
			H[i][1] = b;
			H[i][2] = c;
		}
		void setRow(int i, Ttype a[3])
		{
			for (int j = 0; j < 3 ; j++)
			{
				H[i][j] = a[j];
			}
		}
		void setCol(int j, Ttype a, Ttype b, Ttype c)
		{
			H[0][j] = a;
			H[1][j] = b;
			H[2][j] = c;
		}
		void setCol(int j, Ttype a[3])
		{
			for (int i = 0; i < 3 ; i++)
			{
				H[i][j] = a[j];
			}
		}
		
		
		Ttype det()
		{
			return 	H[0][0] * H[1][1] * H[2][2]+ H[0][1] * H[1][2] * H[2][0]+
					H[1][0] * H[2][1] * H[0][2]- H[0][2] * H[1][1] * H[2][0]-
					H[0][1] * H[1][0] * H[2][2]- H[1][2] * H[2][1] * H[0][0];
			
		}
		Tensor<Ttype> inv()
		{
			Ttype Hinv[3][3];
			Ttype DetH = this->det();
			
			Hinv[0][0] = (H[1][1] * H[2][2]- H[2][1] * H[1][2])/ DetH;
			Hinv[0][1] = (H[0][2] * H[2][1]- H[0][1] * H[2][2])/ DetH;
			Hinv[0][2] = (H[0][1] * H[1][2]- H[1][1] * H[0][2])/ DetH;
			Hinv[1][0] = (H[1][2] * H[2][0]- H[2][2] * H[1][0])/ DetH;
			Hinv[1][1] = (H[0][0] * H[2][2]- H[2][0] * H[0][2])/ DetH;
			Hinv[1][2] = (H[0][2] * H[1][0]- H[0][0] * H[1][2])/ DetH;
			Hinv[2][0] = (H[1][0] * H[2][1]- H[1][1] * H[2][0])/ DetH;
			Hinv[2][1] = (H[0][1] * H[2][0]- H[0][0] * H[2][1])/ DetH;
			Hinv[2][2] = (H[1][1] * H[0][0]- H[0][1] * H[1][0])/ DetH;
			Tensor<Ttype> a(Hinv);
			//~ Tensor<Ttype> a;
			return a;
			//~ return Tensor<Ttype> Hinv;
		}
		Ttype getVal(int i, int j)
		{
			return H[i][j];
		}
		Ttype & val(int i, int j)
		{
			return H[i][j];
		}
		
		template<typename Vtype>
		Vector<Vtype> operator*(Vector<Vtype> v2) const
		{
			Vector<Vtype> v1;
			/// mine
			(v1).x = (Vtype)( (v2).x * H[0][0] + (v2).y * H[0][1] + (v2).z * H[0][2] );
			(v1).y = (Vtype)( (v2).x * H[1][0] + (v2).y * H[1][1] + (v2).z * H[1][2] );
			(v1).z = (Vtype)( (v2).x * H[2][0] + (v2).y * H[2][1] + (v2).z * H[2][2] );
			
			
			return v1;
		}
		friend std::ostream & operator<<(std::ostream & os, const Tensor<Ttype>  & M)
		{
			os << " [" << M.H[0][0] << " , " << M.H[0][1] << " , " << M.H[0][2] << " ; \n" ;
			os << "  " << M.H[1][0] << " , " << M.H[1][1] << " , " << M.H[1][2] << " ; \n" ;
			os << "  " << M.H[2][0] << " , " << M.H[2][1] << " , " << M.H[2][2] << " ] \n" ;
		}
		//~ Ttype*[3] getM3()
		//~ {
			//~ return H;
		//~ }
};



}

#endif
