// MDR
// version 1.0
// Sept 10, 2014
// Author: Vi Q. Ha

#ifndef VAMDE_R_POINTERS_H
#define VAMDE_R_POINTERS_H
#include "MDR.h"
#include <boost/mpi.hpp>

namespace mdr {


class Pointers {
public:
	
	Pointers(MDR *ptr) :
    vmd(ptr),
	parameters(ptr->parameters),
	neighbor(ptr->neighbor),
	properties(ptr->properties),
	data(ptr->data),
	thermostat(ptr->thermostat),
	context(ptr->context),
	agentNetwork(ptr->agentNetwork),
	continuousSpace(ptr->continuousSpace),
	comm(ptr->comm){}
    //~ memory(ptr->memory),


protected:
	MDR * vmd;
	mdr::Parameters  *& parameters;

	Neighbor *&neighbor;
	Props *& properties;
	Data *& data;
	Thermo *& thermostat;

	CONTEXT_TYPE *&context;
	NETWORK_TYPE *&agentNetwork;
	SPACE_TYPE *&continuousSpace;
	boost::mpi::communicator *&comm;

};

}

#endif
