// MDR
// version 3.0
// September 14, 2014
// Authors: Vi Q. Ha


#ifndef VMD_PROPS_H
#define VMD_PROPS_H

#include "pointers.h"

namespace mdr {

class Props : protected Pointers {

    private:
		double dispHi;
		int nebrNow;
		int last_aquired_t;//***

    public:
		Props(class MDR *);
		double virSum; // Edited By Vi on 2014/10/23
		double uSum; // Edited By Vi on 2014/12/17

		double get_vMax_LOCAL();
		double get_vMax_GLOBAL();
		double get_vvSum_LOCAL();
		double get_vvSum_GLOBAL();
		
		double get_virSum_GLOBAL();
		
		double eval_Pressure();
		double eval_Pressure(int d);
		double eval_Density(int d);
		double eval_Density2();
		double eval_Density3();
		
		void print_pressure();
		void print_pressure(int d);
		//~ 
		int get_nebrNow();
		int set_nebrNow(int set_val)
		{
			nebrNow = set_val;
		}
		void reset_dispHi(){dispHi = 0;};

};

}

#endif
