// MDR
// version 3.0
// September 12, 2014
// Authors: Vi Q. Ha


#ifndef VMD_THERMO_H
#define VMD_THERMO_H

#include "pointers.h"

namespace mdr {

class Thermo : protected Pointers {

    private:

	protected: 
		double berendsenCoupl;
		double varS, varSv, varSa; 
		double massS;

    public:
		Thermo(class MDR *);


		//~ 
		void set_berendsenCoupl(double _berendsenCoupl) {berendsenCoupl = _berendsenCoupl;}
		void set_massS(double _massS) {massS = _massS;}
		
		
		double get_vvSum_LOCAL();
		double get_vvSum_GLOBAL();
		void NoseHooverLeapfrogStep(int PART);
		void Berendsen();
		void NoseHoover();

		//~ 
		//~ void NoseHoover_LeapfrogStep(int PART);
		//~ void NoseHoover(CONTEXT_TYPE & context);
		//~ 
		void print_vvSum();
};

}

#endif
